package de.fraunhofer.iem.dataprovider.tool.entity

import de.fraunhofer.iem.dataprovider.tool.dto.ToolEntityResponseDto
import de.fraunhofer.iem.dataprovider.tool.enumeration.ToolType
import jakarta.persistence.*
import org.hibernate.Hibernate
import java.util.*

@Entity
@Table(name = "tool")
class ToolEntity(
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null,

    @Column(name = "name", length = 500, nullable = false)
    val name: String,

    @Enumerated(EnumType.STRING)
    var toolType: ToolType,
) {

    fun toDto(): ToolEntityResponseDto {
        return ToolEntityResponseDto(this.id!!, this.name, this.toolType.getName())
    }

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || Hibernate.getClass(this) != Hibernate.getClass(other)) return false
        other as ToolEntity

        return id != null && id == other.id
    }

    override fun hashCode(): Int = javaClass.hashCode()
}
